#!/bin/sh
#THIS SCRIPT IS ONLY FOR BarryK
#install pets and sfs.
#20220206 fixes.

. /etc/DISTRO_SPECS
KERNELVERSION="`uname -r`"

cd /usr/src
if [ ! -d linux-${KERNELVERSION} ];then
 echo "Folder linux-${KERNELVERSION} does not exist"
 exit
fi

DASHOUT="`find /usr/src -maxdepth 1 -type d -name "out-k${KERNELVERSION}-*"`"
if [ "$DASHOUT" ];then
 POSTVER="-`echo -n "$DASHOUT" | rev | cut -f 1 -d '-' | rev`" #ex: -43
else
 POSTVER=""
fi

if [ ! -d out-k${KERNELVERSION}${POSTVER} ];then
 echo "Folder out-k${KERNELVERSION}${POSTVER} does not exist"
 exit
fi

PETPATH="/mnt/sda1/bk/projects/woof/woof-project/pet-construction/${DISTRO_TARGETARCH}/pet_packages-${DISTRO_COMPAT_VERSION}"
if [ ! -d ${PETPATH} ];then
 echo "Path ${PETPATH} does not exist"
 exit
fi

DISTROPATH="/mnt/sda1/bk/projects/woof/woof-project/easyos/easy-distro/${DISTRO_TARGETARCH}/${DISTRO_BINARY_COMPAT}/${DISTRO_COMPAT_VERSION}"
if [ ! -d ${DISTROPATH} ];then
 echo "Path ${DISTROPATH} does not exist"
 exit
fi
if [ ! -f ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official ];then
 echo "File ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official does not exist"
 exit
fi

SFSPATH="/mnt/sda1/bk/www/ibiblio/easyos/${DISTRO_TARGETARCH}/packages/sfs/easyos/${DISTRO_BINARY_COMPAT}/${DISTRO_COMPAT_VERSION}"
if [ ! -d ${SFSPATH} ];then
 echo "Path ${SFSPATH} does not exist"
 exit
fi

REPOPATH="/mnt/sda1/bk/projects/woof/woof-project/local-repositories/${DISTRO_TARGETARCH}/packages-${DISTRO_BINARY_COMPAT}-${DISTRO_COMPAT_VERSION}"
if [ ! -d ${REPOPATH} ];then
 echo "Path ${REPOPATH} does not exist"
 exit
fi

PETPOSTSTR="$(find out-k${KERNELVERSION}${POSTVER} -mindepth 1 -maxdepth 1 -name "linux_kernel-${KERNELVERSION}${POSTVER}-*.pet" | sed -e "s%out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-%%" | sed -e 's%\.pet$%%')"


if [ -f ${PETPATH}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet ];then
 echo "PET linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet already installed"
 exit
fi

if [ ! -f out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet ];then #sanity check
 echo "File out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet missing"
 exit
fi

echo
echo "INSTALLING: out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet"
cp -a out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet ${PETPATH}/
sync
cd ${PETPATH}
tar -zxf linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet 2>/dev/null
echo "  adding entry to Packages-pet-${DISTRO_COMPAT_VERSION}-official"
cat linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/pet.specs >> ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
sort --key=1,1 --field-separator='|' ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official > /tmp/4installsh-tmp
mv -f /tmp/4installsh-tmp ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
cd /usr/src
echo "  copying PET to local repository"
cp -a -f out-k${KERNELVERSION}${POSTVER}/linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet ${REPOPATH}/
echo " updating DISTRO_KERNEL_PET variable in file DISTRO_SPECS"
PTNk="s%^DISTRO_KERNEL_PET=.*%DISTRO_KERNEL_PET='linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet'%"
sed -i -e "$PTNk" ${DISTROPATH}/DISTRO_SPECS
sync

echo -n "ENTER to continue: "
read keepgoing

echo
echo "INSTALLING: out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}.pet"
cp -a out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}.pet ${PETPATH}/
cd ${PETPATH}
tar -zxf linux_headers-${KERNELVERSION}${POSTVER}.pet 2>/dev/null
echo "  adding entry to Packages-pet-${DISTRO_COMPAT_VERSION}-official"
cat linux_headers-${KERNELVERSION}${POSTVER}/pet.specs >> ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
sort --key=1,1 --field-separator='|' ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official > /tmp/4installsh-tmp
mv -f /tmp/4installsh-tmp ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
cd /usr/src
echo "  copying PET to local repository"
cp -a -f out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}.pet ${REPOPATH}/
sync

echo -n "ENTER to continue: "
read keepgoing

BCSTA="$(find out-k${KERNELVERSION}${POSTVER} -mindepth 1 -maxdepth 1 -type f -name 'broadcom-sta*.pet' | head -n 1)"
if [ "$BCSTA" ];then
 echo
 echo "INSTALLING: ${BCSTA}"
 cp -a ${BCSTA} ${PETPATH}/
 BCbase="$(basename $BCSTA .pet)"
 cd ${PETPATH}
 tar -zxf ${BCbase}.pet 2>/dev/null
 echo "  adding entry to Packages-pet-${DISTRO_COMPAT_VERSION}-official"
 cat ${BCbase}/pet.specs >> ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
 sort --key=1,1 --field-separator='|' ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official > /tmp/4installsh-tmp
 mv -f /tmp/4installsh-tmp ${DISTROPATH}/Packages-pet-${DISTRO_COMPAT_VERSION}-official
 cd /usr/src
 echo "  copying PET to local repository"
 cp -a -f out-k${KERNELVERSION}${POSTVER}/${BCbase}.pet ${REPOPATH}/
 sync
fi

echo -n "ENTER to continue: "
read keepgoing

echo
echo "INSTALLING: kernel_${KERNELVERSION}${POSTVER}-p1_src.sfs"
cp -a -f out-k${KERNELVERSION}${POSTVER}/kernel_${KERNELVERSION}${POSTVER}-p1_src.sfs ${SFSPATH}/
cp -a -f out-k${KERNELVERSION}${POSTVER}/kernel_${KERNELVERSION}${POSTVER}-p1_src.specs ${SFSPATH}/
cp -a -f out-k${KERNELVERSION}${POSTVER}/kernel.png ${SFSPATH}/
sync

echo -n "ENTER to continue: "
read keepgoing

echo
echo "INSTALLING: kernel source, patches, scripts"
KERN2="$(echo -n "$KERNELVERSION" | cut -f 1,2 -d '.')"
SRCPATH="/mnt/sda1/bk/www/ibiblio/easyos/source/kernel/${KERN2}.x/${KERNELVERSION}${POSTVER}"
mkdir -p ${SRCPATH}/build-kernel
cp -a out-k${KERNELVERSION}${POSTVER}/3rd-party ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/patches ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/1kernel.sh ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/1recompile.sh ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/2modules.sh ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/3package.sh ${SRCPATH}/build-kernel/
cp -a 4install.sh ${SRCPATH}/build-kernel/
cp -a out-k${KERNELVERSION}${POSTVER}/DOTconfig-${KERNELVERSION}${POSTVER} ${SRCPATH}/build-kernel/
cp -a ec-kernel48.png ${SRCPATH}/build-kernel/ #20220106
cp -a ec-overlay48.png ${SRCPATH}/build-kernel/ #20220106
cp -a kernel48.png ${SRCPATH}/build-kernel/ #20220106
cp -a pngoverlay ${SRCPATH}/build-kernel/ #20220106
cp -a bk-readme.htm ${SRCPATH}/build-kernel/ #20220106
cp -a bk-readme.htm ${SRCPATH}/
cp -a linux-${KERN2}.tar.bz2 ${SRCPATH}/
sync
cd ${SRCPATH}
dir2tgz build-kernel
sync
rm -rf build-kernel
md5sum * > md5sums.txt
cd /usr/src

echo "...done"
###end###
